#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

#define FONTBOLD      "Bold"    // change to "Fett" for German versions
#define FONTITALIC    "Italic"  // change to "Kursiv" for German versions
#define CRLF          Chr(13)+Chr(10)

//#pragma library("dir c:\exp20dclipx.lib")
//#pragma library("dclip1.lib") // for DC_LoadRdds()

FUNCTION Main ()
 LOCAL GetList:={},GetOptions, oTabPage1, oBrowseC
LOCAL  aCalendar[300,7], lOwnerDraw := .t., ;
      aPres, nRow

LOCAL lObn:=.f., aPraz:={},cTxt, i,k
PUBLIC NetIme


m->NetIme:='Janko'
if file('aPraz.arr')
       aPraz:=dc_arestore('aPraz.arr')
endif
aPres := ;
      { { XBP_PP_COL_DA_ROWHEIGHT, 140 }, ;  // rows are 48 pixels high
        { XBP_PP_COL_DA_CELLHEIGHT, 140 } ,;
        { XBP_PP_COL_DA_HILITE_BGCLR, GraMakeRGBColor({204,255,191}) },;   // Hilite BG color
        { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_LINE },   /* Row Sep  */     ;
        { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_LINE } }  /* Col Sep  */

DC_LoadRdds()

USE calendar VIA 'FOXCDX' INDEX calendar
CALENDAR->(OrdSetFocus('DATE'))

// Prazniki.txt == holidays.txt  -> transfered to Praz.arr
 	if file('Prazniki.txt') .and. file('Praz.arr')
      lObn:=dtos(Directory("Prazniki.txt")[1,3]) + Directory("Prazniki.txt")[1,4]   > dtos(Directory("Praz.arr")[1,3]) + Directory("Praz.arr")[1,4]
 //		wtf  dtos(Directory("Jeziki.txt")[1,3]) + Directory("Jeziki.txt")[1,4], dtos(Directory("mjv.arr")[1,3]) + Directory("mjv.arr")[1,4]   ,      lObn pause
	endif
 // wtf aPraz, lObn, file('Prazniki.txt') PAUSE
if !file('Praz.arr') .or. empty(aPraz)   .or. lObn              // ali gremo obnavljati mjv.arr iz Jeziki.txt
   ctxt:= memoread('Prazniki.txt')                               //, mjW:={}, i,k:=mlCount(cTxt,160)
	k:=mlCount(cTxt,80)
 for i:=1 to k
	  aadd(aPraz, dc_tokenarray(memoline(ctxt,80,i),';',.f.))
 next i
       dc_asave(aPraz,'Praz.arr' )
Endif
////   end Prazniki.txt

//wtf   aPraz PAUSE
nRow := LoadCalendarArray(aCalendar)


@ 2,2 DCBROWSE oBrowseC DATA aCalendar SIZE 96,30 PRESENTATION aPres FIT  PARENT oTabPage1;
      SUBCLASS 'DC_XbpOwnerDrawBrowseGeneric()' USEVISUALSTYLE ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      RESIZECOLUMNS ;
      PREEVAL {|o|o:lOwnerDraw := .t., ;
                  o:stdFontCompoundName := '10.Tahoma', ;
                  o:boldFontCompoundName := '10.Tahoma '+FONTBOLD, ;
                  o:boldItalicFontCompoundName := '12.Tahoma '+FONTBOLD+' '+FONTITALIC} ;
      ITEMSELECTED {||EditCell(oBrowseC)}   ;
	   EVAL {||oBrowseC:arrayElement := nRow, oBrowseC:refreshAll()}


/*DCBROWSECOL DATA {||CellArray(1,oBrowse,.f.)} ;
                    HEADER 'Sunday' WIDTH 10 PARENT oBrowse ;
                    OWNERDRAW ;
                    COLOR {||CellArray(1,oBrowse,.t.)}        */

DCBROWSECOL DATA {||CellArray(1,oBrowseC,.f.,apraz)} ;
                    HEADER 'Ponedeljek' WIDTH 10.2 PARENT oBrowseC ;
                    OWNERDRAW ;
                    COLOR {||CellArray(1,oBrowseC,.t.)}

DCBROWSECOL DATA {||CellArray(2,oBrowseC,.f.,aPraz)} ;
                    HEADER 'Torek' WIDTH 10.2 PARENT oBrowseC ;
                    OWNERDRAW ;
                    COLOR {||CellArray(2,oBrowseC,.t.)}

DCBROWSECOL DATA {||CellArray(3,oBrowseC,.f.,aPraz)} ;
                    HEADER 'Sreda' WIDTH 10.2 PARENT oBrowseC ;
                    OWNERDRAW ;
                    COLOR {||CellArray(3,oBrowseC,.t.)}

DCBROWSECOL DATA {||CellArray(4,oBrowseC,.f.,aPraz)} ;
                    HEADER 'etrtek' WIDTH 10.2 PARENT oBrowseC ;
                    OWNERDRAW ;
                    COLOR {||CellArray(4,oBrowseC,.t.)}

DCBROWSECOL DATA {||CellArray(5,oBrowseC,.f.,aPraz)} ;
                    HEADER 'Petek' WIDTH 10.2 PARENT oBrowseC ;
                    OWNERDRAW ;
                    COLOR {||CellArray(5,oBrowseC,.t.)}

DCBROWSECOL DATA {||CellArray(6,oBrowseC,.f.,aPraz)} ;
                    HEADER 'Sobota' WIDTH 10.2 PARENT oBrowseC ;
                    OWNERDRAW ;
                    COLOR {||CellArray(6,oBrowseC,.t.)}

DCBROWSECOL DATA {||CellArray(7,oBrowseC,.f.,aPraz)} ;
                    HEADER 'Nedelja' WIDTH 10 PARENT oBrowseC ;
                    OWNERDRAW ;
                    COLOR {||CellArray(7,oBrowseC,.t.)}


//@ 26,0 DCCHECKBOX lOwnerDraw PROMPT 'Use ownerdrawing' ;
//       ACTION {||oBrowse:lOwnerDraw := lOwnerDraw,oBrowse:InvalidateRect()}

DCGETOPTIONS RESIZE

DCREAD GUI FIT TITLE 'Calendar sample' OPTIONS GetOptions ;
 //  EVAL {||oBrowse:arrayElement := nRow, oBrowse:refreshAll()}

RETURN nil

PROC appsys ; RETURN

* ------------

STATIC FUNCTION LoadCalendarArray( aCalendar )
******************************************************************************************************************
LOCAL nCol, dDate, nLen, i, j, nRow := 1

nCol := 1
dDate := Date()
dDate -= 365

DO WHILE Dow(dDate)<> 2
  dDate--
ENDDO

nLen := Len(aCalendar)

FOR i := 1 TO nLen
  FOR j := 1 TO 7

    aCalendar[i,j] := { dDate, {} }
    CALENDAR->(dbSeek(Dtos(dDate)))
    DO WHILE CALENDAR->date == dDate .AND. !CALENDAR->(Eof())
	 if padr(CALENDAR->uporabnik,10,' ')==padr(M->NetIme,10,' ')      .or. CALENDAR->javno
      AAdd( aCalendar[i,j,2], ;
           { CALENDAR->time, ;                                         // 1
             Substr(Sec2Time(CALENDAR->time),1,5), ;                   // 2
             CALENDAR->duration, ;                                     // 3
             Substr(Sec2Time(CALENDAR->duration),1,5), ;               // 4
             CALENDAR->short, ;                                        // 5
             CALENDAR->memo, ;                                         // 6
             CALENDAR->(RecNo()),;                                     // 7
   			 CALENDAR->uporabnik,;                                     // 8 user
   			 CALENDAR->javno,;                                         // 9 public announcement
	   		 CALENDAR->timestamp   			  } )                      // 10
	 endif

      CALENDAR->(dbSkip())
    ENDDO
    dDate++
    IF dDate == Date()
      nRow := i
    ENDIF
  NEXT
NEXT

// dc_arrayview(aCalendar)
RETURN nRow
********************************************************************************************************************
STATIC FUNCTION RefreshCell(aCalendar,i,j)
********************************************************************************************************************
LOCAL aCell := aCalendar[i,j]
LOCAL dDate := aCell[1]
LOCAL aAppts := AClone(aCell[2])


    aCalendar[i,j] := { dDate, {} }
    CALENDAR->(dbSeek(Dtos(dDate)))
    DO WHILE CALENDAR->date == dDate .AND. !CALENDAR->(Eof())
	 if padr(CALENDAR->uporabnik,10,' ')==padr(M->NetIme,10,' ')      .or. CALENDAR->javno
      AAdd( aCalendar[i,j,2], ;
           { CALENDAR->time, ;                                         // 1
             Substr(Sec2Time(CALENDAR->time),1,5), ;                   // 2
             CALENDAR->duration, ;                                     // 3
             Substr(Sec2Time(CALENDAR->duration),1,5), ;               // 4
             CALENDAR->short, ;                                        // 5
             CALENDAR->memo, ;                                         // 6
             CALENDAR->(RecNo()),;                                     // 7
		   	 CALENDAR->uporabnik,;                                     // 8
			    CALENDAR->javno,;                                         // 9
			    CALENDAR->timestamp   			  } )                        // 10
	 endif

      CALENDAR->(dbSkip())
    ENDDO


return nil


*********************************************************************************************************************
STATIC FUNCTION EditCell( oBrowseC )
*********************************************************************************************************************

LOCAL i := oBrowseC:arrayElement
LOCAL j := oBrowseC:colPos
LOCAL aCalendar := oBrowseC:dataSource
LOCAL oBrowseCell, GetList[0], GetOptions
LOCAL aCell := aCalendar[i,j]
LOCAL dDate := aCell[1], bGetSet, oMle
LOCAL aAppts := AClone(aCell[2]), nPointer := 0, lStatus ,aDelAppts:={}, k:={i,j}


  RefreshCell( aCalendar, i,j )
  oBrowseC:refreshAll()
  aCell := aCalendar[i,j]
  dDate := aCell[1]
  aAppts := AClone(aCell[2])

/*   e je aAppts prazen, dodaj en element



  */
@ 0,0 DCBROWSE oBrowseCell DATA aAppts SIZE 50,10 FIT ;
      FONT '10.Courier' ;
      NOHSCROLL ;                                                                                        // padr(aaPpts[npointer,8],10,' ')==padr(M->NetIme,10,' ')
      ITEMMARKED {||DC_GetRefresh(oMle)} ;                                                               // DCGUI_IGNORE
      POINTER nPointer ;
      EDIT xbeBRW_ItemSelected MODE DCGUI_BROWSE_EDITACROSS ;
      EXIT {||ASort(aAppts,,,{|a,b|a[1]<b[1]}),oBrowseCell:refreshAll()}

DCBROWSECOL ELEMENT 2 HEADER 'Kdaj' WIDTH 6 PARENT oBrowseCell PICTURE "99:99" ;
   VALID {||ValidateAppt(aAppts[nPointer],1)}  PROTECT {||!padr(aaPpts[npointer,8],10,' ')==padr(M->NetIme,10,' ')}
DCBROWSECOL ELEMENT 4 HEADER 'as' WIDTH 6 PARENT oBrowseCell PICTURE "99:99" ;
   VALID {||ValidateAppt(aAppts[nPointer],2)}  PROTECT {||!padr(aaPpts[npointer,8],10,' ')==padr(M->NetIme,10,' ')}
   DCBROWSECOL ELEMENT 5 HEADER 'O em' WIDTH 50 PARENT oBrowseCell ;
   VALID {||ValidateAppt(aAppts[nPointer],3)}  PROTECT {||!padr(aaPpts[npointer,8],10,' ')==padr(M->NetIme,10,' ')}
DCBROWSECOL ELEMENT 9 HEADER 'Javno' WIDTH 3 PICTURE 'Y' PARENT oBrowseCell     PROTECT {||!padr(aaPpts[npointer,8],10,' ')==padr(M->NetIme,10,' ') }



bGetSet := {|x|IIF(nPointer==0,'',IIF(x==nil,aAppts[nPointer,6],aAppts[nPointer,6]:=x))}
@ 11,0 DCMULTILINE bGetSet SIZE 80,9 ;
       FONT '10.YU Gothic' ;
       OBJECT oMle   EDITPROTECT {|| if(nPointer==0,.t.,! (padr(aaPpts[npointer,8],10,' ')==padr(M->NetIme,10,' ')))}

@ 21,0 DCPUSHBUTTON CAPTION 'Obrii' SIZE 9,1 ;
       ACTION {||if(padr(aaPpts[npointer,8],10,' ')==padr(M->NetIme,10,' '),(aaDD(aDelAppts,aAppts[npointer]),aRemove(aAppts,nPointer),oBrowseCell:refreshAll()),)} ;
       WHEN {||nPointer > 0}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Novo' SIZE 9,1 ;
       ACTION {||AAdd(aAppts,{0,Space(5),0,Space(5),Space(50),'',0,m->NetIme,.f.,Dtos(date())+' '+time()}), ;
                 DC_GetRefresh(GetList), ;
                 oBrowseCell:goBottom(),PostAppEvent(xbeBRW_ItemSelected,,,oBrowseCell)} ;

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'OK' SIZE 9,1 ;
       ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Ni' SIZE 9,1 ;
       ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}

DCREAD GUI FIT TITLE 'Dogodki: ' + Dtoc(dDate) TO lStatus

IF lStatus
  FOR i := 1 TO Len(aAppts)
    IF !Empty(aAppts[i,7])
      CALENDAR->(dbGoTo(aAppts[i,7]))
      CALENDAR->(DC_RecLock())
    ELSE
      CALENDAR->(DC_AddRec())
    ENDIF
    CALENDAR->date := dDate
    CALENDAR->time := aAppts[i,1]
    CALENDAR->duration := aAppts[i,3]
    CALENDAR->short := aAppts[i,5]
    CALENDAR->memo := aAppts[i,6]
    aAppts[i,7] := CALENDAR->(RecNo())
	CALENDAR->uporabnik:= aAppts[i,8]                                     // 8
	CALENDAR->javno:= aAppts[i,9]                                         // 9
	CALENDAR->timestamp:=aAppts[i,10]   			                      // 10

    CALENDAR->(dbRUnlock())
  NEXT
  FOR i:=1 to len(aDelAppts)
   Calendar->(dbgoto(aDelAppts[i,7]))
   if calendar->(rlock())
	  calendar->(dbdelete())
   endif
  NEXT i
  RefreshCell( aCalendar, k[1],k[2] )
  oBrowseC:refreshAll()
ENDIF



 //dc_arrayview(aDelAppts)
RETURN nil

* ------------

STATIC FUNCTION ValidateAppt( aAppt, nWhich )

LOCAL lStatus := .f., nTime

IF nWhich == 1 // Time
  nTime := Time2Sec(aAppt[2])
  IF nTime > 24*60*60
  ELSE
    aAppt[1] := nTime
    lStatus := .t.
  ENDIF
ELSEIF nWhich == 2 // Duration
  nTime := Time2Sec(aAppt[4])
  IF nTime > 24*60*60
  ELSE
    aAppt[3] := nTime
    lStatus := .t.
  ENDIF
ELSEIF nWhich == 3 // Subject
  lStatus := !Empty(aAppt[5])
ENDIF

RETURN lStatus

* ------------

STATIC FUNCTION Time2Sec( cTime )

LOCAL nTime

nTime := (Val(Substr(cTime,1,2)) * 3600) + (Val(Substr(cTime,4,2 )) * 60)

RETURN nTime

* ------------

STATIC FUNCTION CellArray( nCol, oBrowseC, lColor, aPraz )

LOCAL aCalendar := oBrowseC:dataSource
LOCAL nElement := oBrowseC:arrayElement
LOCAL aCell := aCalendar[nElement,nCol]
LOCAL dDate := aCell[1], aData, i, aAppt
LOCAL nCellWidth := 120, nFGColor
LOCAL cPraz, lCol:=.f., lPraz:=.f. , nPraz:=0

IF oBrowseC:colCount >= nCol
  nCellWidth := oBrowseC:getColumn(nCol):dataArea:currentSize()[1]
ENDIF

/*
  [1] = <ocData>
  [2] = <nCol>
  [3] = <nRow>
  [4] = <nWidth>
  [5] = <nHeight>
  [6] = <font>
  [7] = <selectedFont>
  [8] = <fgColor>
 [ 9] = <bgColor>
 [10] = <nAlign>
*/

//wtf ddate , ctod(aPraz[1,1]) PAUSE

nPraz:= ascan(aPraz,{|x,i|ddate==ctod(x[1])})
lPraz:= nPraz > 0

if nPraz > 0
	cPraz:= cpxy(aPraz[nPraz,2] )
	lCol:=If('R'$ aPraz[nPraz,3],.t.,.f.)
endif

IF lColor

  IF Month(dDate) % 2 == 0
    aData := { nil, GraMakeRGBColor({255,255,255}) }
  ELSE
    aData := { nil, GraMakeRGBColor({25,250,255}) }
  ENDIF

ELSE

 IF dow(ddate)=1 .or. dow(ddate)=7 .or. lCol
	nFgColor:= GRA_CLR_RED
 else
	nFGColor:= GRA_CLR_BLUE
 endif

  IF dDate == Date()
    nFGColor := GRA_CLR_DARKRED
  ENDIF
				 //Week( [<dDate>], [<lSundayIsFirstDayOfWeek>] )
  aData := { { Alltrim(Str(Year(dDate))) + ' ' + substr(CMonth(dDate),1,3),10,3,100,30,'10.Arial',,nFGColor }, ;
             { Alltrim(Str(Day(dDate))),nCellWidth-50,7,50,40,'28.Arial Bold',,nFGColor,,XBPALIGN_RIGHT },;
   			 {'KT: '+ Alltrim(Str(week(dDate,.f.),3)),nCellWidth-110,30,40,20,'10.Arial Bold',,nFGColor,,XBPALIGN_RIGHT } }

 if lPraz
	  aadd (aData,{cPraz ,nCellWidth-110,45,,40,'10.Arial Bold',,nFGColor,,XBPALIGN_LEFT }         )
	endif
  aAppt := aCell[2]
 *******************************************-----------------------------------------------------------praznik
  FOR i := 1 TO Len(aAppt)
    AAdd(aData,{aAppt[i,2] + ' > ' + aAppt[i,5],10,60+((i-1)*15),,18,'7.Arial CE',,GRA_CLR_DARKPINK})
  NEXT

ENDIF

RETURN aData

* ----------

STATIC FUNCTION Sec2Time ( nSeconds )

LOCAL nHours, nMinutes

nSeconds := IIF(Valtype(nSeconds)='N',nSeconds,Seconds())

nHours   := nSeconds / (60*60)
nMinutes := nHours - Int(nHours)
nHours   := Int(nHours)
nMinutes := nMinutes * 60
nSeconds := Int( ( nMinutes - Int(nMinutes) ) * 60 )

RETURN StrTran(Str(nHours,2)+':'+Str(nMinutes,2)+':'+Str(nSeconds,2),' ','0')



****************************************************************************************************   conversion functions  *******************************
static function cpxx(cKaj)                        // array s 蚞 se zapie
*****************************************************************************************************
return menjajj(cKaj,chr(159)+chr(231)+chr(167)+chr(172)+chr(230)+chr(166)+chr(134)+chr(208)+chr(143)+chr(209),;
                   chr(232)+chr(154)+chr(158)+chr(200)+chr(138)+chr(142)+chr(230)+chr(240)+chr(198)+chr(208)          )
**************************************************************************************************************
static function cpxy(cKaj)
**************************************************************************************************************
return menjajj(cKaj,chr(232)+chr(154)+chr(158)+chr(200)+chr(138)+chr(142)+chr(230)+chr(240)+chr(198)+chr(208) ,;
                   chr(159)+chr(231)+chr(167)+chr(172)+chr(230)+chr(166)+chr(134)+chr(208)+chr(143)+chr(209)          )


************************************************************************************************************************************
static Function Menjajj(cStr,iz,v)
************************************************************************************************************************************
//LOCAL iz:= {159, 134, 231, 167, 208, 172, 143, 230, 166, 209 }
//LOCAL  v:= {232, 230, 154, 158, 240, 200, 198, 138, 142, 208 }
LOCAL i  ,cIz,cVh


for  i:=len(iz) to 1 step -1
	 cVh:=(v[i])
	 cIz:=(iz[i])
	 cStr:=StrTran (cStr,cIz,cVh)
Next i

Return cStr



